{-#  OPTIONS --type-in-type --without-K  #-}

open import Preliminaries

module Circle where

  module S¹ where
    private
      data S¹' : Set where
        Base : S¹'

    S¹ : Set
    S¹ = S¹'

    base : S¹
    base = Base

    postulate
      loop : Path base base

    S¹-recursion : {C : Set} 
           -> (c : C)
           -> (α : c ≃ c)
           -> S¹ -> C
    S¹-recursion a _ Base = a

    S¹-induction :  (C : S¹ -> Set)
            -> (c : C base) 
               (α : Path (transport C loop c) c)
            -> (x : S¹) -> C x
    S¹-induction _ x _ Base = x

    postulate 
      βloop/rec : {C : Set} 
           -> (c : C)
           -> (α : Path c c)
           -> Path (ap (S¹-recursion c α) loop) α

      βloop/elim : {C : S¹ -> Set} 
                 -> (c : C base) (α : Path (transport C loop c) c)
                 -> Path (apd (S¹-induction C c α) loop) α
  
  open S¹ public
